<?php

// get the time
$time = time();
$cache = apc_cache_info();
$sma_info = apc_sma_info();

$cached_files = count($cache['cache_list']);

// memory info
$total_mem = $sma_info['num_seg'] * $sma_info['seg_size'];
$mem_used = $total_mem - $sma_info['avail_mem'];
$mem_free = $sma_info['avail_mem'];
$num_fragments = count($sma_info['block_lists'][0]);

// request info
$req_rate = sprintf("%.2f",($cache['num_hits']+$cache['num_misses'])/($time-$cache['start_time']));
$hit_rate = sprintf("%.2f",($cache['num_hits'])/($time-$cache['start_time']));
$miss_rate = sprintf("%.2f",($cache['num_misses'])/($time-$cache['start_time']));
$insert_rate = sprintf("%.2f",($cache['num_inserts'])/($time-$cache['start_time']));

// print it all out in a format cacti understands
echo "cached_files:" . $cached_files;
echo " mem_total:" . $total_mem;
echo " mem_used:" . $mem_used;
echo " mem_free:" . $mem_free;
echo " num_fragments:" . $num_fragments;
echo " request_rate:" . $req_rate;
echo " hit_rate:" . $hit_rate;
echo " miss_rate:" . $miss_rate;
echo " insert_rate:" . $insert_rate;
